
%q-composite,q=2
m=20;
s1=340;
q1=2;
x0=0:10:450;
p0=zeros(1,size(x0,2));
for j=1:size(x0,2)
    for i=q1:m
        p11=(1-(1-m/s1)^x0(j))^i;
        p22=nchoosek(s1,i)*nchoosek(s1-i,2*(m-i))*nchoosek(2*(m-i),m-i)/((nchoosek(s1,m))^2);
        p0(j)=p0(j)+p11*p22;
    end
    p0(j)=p0(j)/0.332;
end

%q-composite,q=3
m=20;
s2=200;
q2=3;
x1=0:10:450;
p1=zeros(1,size(x1,2));
for j=1:size(x1,2)
    for i=q2:m
        H1=(1-(1-m/s2)^x1(j))^i;
        H2=nchoosek(s2,i)*nchoosek(s2-i,2*(m-i))*nchoosek(2*(m-i),m-i)/((nchoosek(s2,m))^2);
        p1(j)=p1(j)+H1*H2;
    end
    p1(j)=p1(j)/0.32;
end

%Our scheme,t=1,r=1
x2=1:10:450;
p2=zeros(1,size(x2,2));
r=0;
t=1;
for i=1:t
    r=r+2^(t-i);
end

w=((r+1)^2)^((r+1)^2);

for i=1:size(x2,2)
   for j=0:r
       p2(i)=p2(i)+nchoosek(x2(i),j)*(1/w)^j*(1-1/w)^(x2(i)-j);
   end
   p2(i)=1-p2(i);
end



%Liu et al. 
x3=0:10:450;
p3=zeros(1,size(x3,2));
for j=1:size(x3,2)
    for i=(18+1):x3(j)
        p3(j)=p3(j)+nchoosek(x3(j),i)*((2/11)^i)*((1-2/11)^(x3(j)-i));
    end
end

%Zhang et al.
t=18;
m=18;
g=2;
N=200;
x4=0:10:450;
s=12;
w=g*(t+1)+s;
h1=nchoosek(m-g,g)/nchoosek(m,g);
h2=1-((t+1)+s)/(N*g*t);
h3=zeros(1,size(x4,2));
p4=zeros(1,size(x4,2)); 
pL=1-((nchoosek(m-g,g))*nchoosek((w-s)*(N-2),s)*nchoosek((w-s)*(N-2)-s,s))/(nchoosek(m,g)*(nchoosek((w-s)*(N-1),s)^2));
for y=3:size(x4,2)
    for i=0:t
        h3(y)=h3(y)+nchoosek(x4(y),i)*((g/m)^i)*((1-(g/m))^(x4(y)-i));
    end
    p4(y)=(h2^x4(y)-h3(y))*((1-h1)/pL)+(1-h2^x4(y));
end

z=plot(x0,p0,'-ok',x1,p1,'-*k',x2,p2,'-+r',x3,p3,'-*g',x4,p4,'-ob');%z=plot(x,p1,'-ok',x,p2,'-*k',x3,p3,'-or',x4,p4,'-*r',x,p5,'-ob',x,p6,'-*b');
set(z,'linewidth',1);

legend('q-composite,q=2','q-composite,q=3','Our scheme,t=1,\lambda=1','Liu et al,\lambda=18','Zhang et al,\lambda=18');
xlabel('Number of constrained nodes captured');
ylabel('Fraction of links compromised');
hold on
grid on